import threading
import time
from lib.controller import *
from lib.display import *
from lib.log import *
from lib.rgbcolorsensor import *
from lib.rgbcolorsensorutil import *

rgbw = None
hsv = None
hexcode = None


def readSensor():
    global rgbw, hsv, hexcode
    rgbw = get_rgbcolorsensor_color_RGBW(0)
    hsv = rgbw2hsv(rgbw)
    hexcode = rgbw2hex(rgbw)


def threadDisplay():
    global rgbw, hsv, hexcode
    display.set_attr("txt_label_fw.text", str('FW:<b>{}</b>'.format(get_rgbcolorsensor_firmware_version())))
    display.set_attr("txt_slider.enabled", str(True).lower())
    while True:
        if rgbw != None:
            display.set_attr("txt_label_r.text", str('R: {}'.format(rgbw[0])))
            display.set_attr("txt_label_g.text", str('G: {}'.format(rgbw[1])))
            display.set_attr("txt_label_b.text", str('B: {}'.format(rgbw[2])))
            display.set_attr("txt_label_w.text", str('W: {}'.format(rgbw[3])))
            display.set_attr("txt_label_leds.text", str('{}'.format((get_ledpwms(0))[0])))
        else:
            display.set_attr("txt_label_r.text", str('R:'))
            display.set_attr("txt_label_g.text", str('G:'))
            display.set_attr("txt_label_b.text", str('B:'))
            display.set_attr("txt_label_w.text", str('W:'))
        if hsv != None:
            display.set_attr("txt_label_target.text", str('{}'.format(hsv2target(hsv))))
            display.set_attr("txt_label_c.text", str("<font color='{}'>■</font>".format(hexcode)))
            display.set_attr("txt_label_h.text", str('H: {}'.format(hsv[0])))
            display.set_attr("txt_label_s.text", str('S: {}'.format(hsv[1])))
            display.set_attr("txt_label_v.text", str('V: {}'.format(hsv[2])))
        else:
            display.set_attr("txt_label_target.text", str(''))
            display.set_attr("txt_label_c.text", str(''))
            display.set_attr("txt_label_h.text", str('H:'))
            display.set_attr("txt_label_s.text", str('S:'))
            display.set_attr("txt_label_v.text", str('V:'))
        time.sleep(0.2)


def on_txt_slider_moved(event):
    global rgbw, hsv, hexcode
    init_rgbcolorsensor_LED(0, int(event['value']))


display.slider_moved("txt_slider", on_txt_slider_moved)


init_log(20)
init_rgbcolorsensor()
init_rgbcolorsensorutil()
threading.Thread(target=threadDisplay, daemon=True).start()
while True:
    readSensor()
    time.sleep(0.04)


