import logging
import smbus2

c = None
a = None
idx = None
m = None
led1 = None
led2 = None
led3 = None
led = None
T = None
count_sensors = None
firmware_version = None
measuretime = None
cx = None
pwmled = None
pwmleds = None
mtx = None
tx = None
rx = None
gx = None
bx = None
wx = None
cycle_counter = None
def value2measuretime(T):
    global c, a, idx, m, led1, led2, led3, led, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, T)
    if T == 0:
        measuretime = 40
    elif T == 1:
        measuretime = 80
    elif T == 2:
        measuretime = 160
    elif T == 3:
        measuretime = 320
    elif T == 4:
        measuretime = 640
    elif T == 5:
        measuretime = 1280
    else:
        measuretime = None
    logging.log(logging.DEBUG, measuretime)
    return measuretime



def init_rgbcolorsensor():
    global c, a, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, '-')
    logging.log(logging.INFO, "smbus2 version %s", smbus2.__version__)
    #https://github.com/kplindegaard/smbus2/tree/0.3.0
    global bus, DEVICE_ADDRESS
    bus = smbus2.SMBus(3)
    DEVICE_ADDRESS = 0x14
    cycle_counter = 0
    mtx = [2] * 8
    pwmleds = [[128] * 3] * 8
    tx = [0] * 8
    cx = [0] * 8
    rx = [0] * 8
    gx = [0] * 8
    bx = [0] * 8
    wx = [0] * 8
    if False:
        firmware_version = get_rgbcolorsensor_firmware_version()
        count_sensors = get_rgbcolorsensor_count_sensors()


def print_internals():
    global c, a, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.INFO, 'mtx:{} pwms:{} tx:{} cx:{} rgbwx:{} {} {} {}'.format(mtx, pwmleds, tx, cx, rx, gx, bx, wx))


def get_rgbcolorsensor_count_sensors():
    global c, a, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, '-')
    #RGB_REGISTER_ANZ_SENSOREN
    blockc = bus.read_i2c_block_data(DEVICE_ADDRESS, 0x10, 1)
    logging.log(logging.TRACE0, blockc)
    count_sensors = blockc[0]
    if (count_sensors==0):
      logging.log(logging.ERROR, 'error', count_sensors)
    else:
      logging.log(logging.DEBUG, 'count sensors: {}'.format(str(count_sensors)))
    return count_sensors


def get_rgbcolorsensor_firmware_version():
    global c, a, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, '-')
    #RGB_REGISTER_FW_VERSION
    blockfw = bus.read_i2c_block_data(DEVICE_ADDRESS, 0x11, 2)
    logging.log(logging.TRACE0, blockfw)
    firmware_version = '{}.{}'.format(str(blockfw[1]), str(blockfw[0]))
    logging.log(logging.INFO, 'firmware version: {}'.format(str(firmware_version)))
    return firmware_version


def set_rgbcolorsensor_cycle_counter(c):
    global a, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, c)
    #RGB_REGISTER_SET_CYCLE_COUNTER
    blockcc = bus.write_byte_data(DEVICE_ADDRESS, 0x18, c)
    logging.log(logging.DEBUG, 'set cycle counter: {}'.format(str(c)))


def set_rgbcolorsensor_auto_off_light(a):
    global c, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, a)
    #RGB_REGISTER_SET_AUTO_OFF_LIGHT
    #a=time in s for auto off: pwm=1
    #a=0 no auto off (default)
    blockca = bus.write_byte_data(DEVICE_ADDRESS, 0x19, a)
    logging.log(logging.DEBUG, 'set auto off light: {}'.format(str(a)))


def init_rgbcolorsensor_TIME_LEDS(idx, m, led1, led2, led3):
    global c, a, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, [idx, m, led1, led2, led3])
    #RGB_REGISTER_INIT_SENSOR_X
    #m: measure time
    #0 = 40ms
    #1 = 80ms
    #2 = 160ms (default)
    #3 = 320ms
    #4 = 640ms
    #5 = 1280ms
    blocki = bus.write_i2c_block_data(DEVICE_ADDRESS, (0x40+idx) & 0xff,  [m & 0xff, led1 & 0xff, led2 & 0xff, led3 & 0xff])
    mtx[idx] = m
    pwmleds[idx] = [led1, led2, led3]
    #print(pwmleds)
    logging.log(logging.DEBUG, 'init_sensor{}: m:{} LEDS: {} {} {}'.format(str(idx), str(m), str(led1), str(led2), str(led3)))


def init_rgbcolorsensor_LED(idx, led):
    global c, a, m, led1, led2, led3, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, [idx, led])
    init_rgbcolorsensor_TIME_LEDS(idx, mtx[int((idx + 1) - 1)], led, led, led)


def init_rgbcolorsensor_TIME(idx, m):
    global c, a, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, [idx, m])
    pwmled = pwmleds[int((idx + 1) - 1)]
    init_rgbcolorsensor_TIME_LEDS(idx, m, pwmled[0], pwmled[1], pwmled[2])


def get_rgbcolorsensor_color_RGBW(idx):
    global c, a, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, idx)
    logging.log(logging.TRACE, '-')
    #RGB_REGISTER_GET_COLOR_X
    block1 = bus.read_i2c_block_data(DEVICE_ADDRESS, 0x20+idx, 11)
    logging.log(logging.TRACE0, block1)
    cx[idx] = block1[0]
    rx[idx] = 256*block1[2] +block1[1]
    gx[idx] = 256*block1[4]+block1[3]
    bx[idx] = 256*block1[6]+block1[5]
    wx[idx] = 256*block1[8]+block1[7]
    tx[idx] = 256*block1[10] +block1[9]
    logging.log(logging.DEBUG, 'get_color_{}: c:{} rgbw:{} {} {} {} # t:{}'.format(str(idx), str(cx[idx]), str(rx[idx]), str(gx[idx]), str(bx[idx]), str(wx[idx]), str(tx[idx])))
    return [rx[int((idx + 1) - 1)], gx[int((idx + 1) - 1)], bx[int((idx + 1) - 1)], wx[int((idx + 1) - 1)]]


def get_rgbcolorsensor_color0_RGBW():
    global c, a, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE, '-')
    return get_rgbcolorsensor_color_RGBW(0)


def get_ledpwms(idx):
    global c, a, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE0, '-')
    return pwmleds[int((idx + 1) - 1)]


def get_measuretimex(idx):
    global c, a, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE0, '-')
    return mtx[int((idx + 1) - 1)]


def get_measuretime0():
    global c, a, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE0, '-')
    return mtx[0]


def get_timex(idx):
    global c, a, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE0, '-')
    return tx[int((idx + 1) - 1)]


def get_time0():
    global c, a, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE0, '-')
    return tx[0]


def get_counterx(idx):
    global c, a, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE0, '-')
    return cx[int((idx + 1) - 1)]


def get_counter0():
    global c, a, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE0, '-')
    return cx[0]


def get_counters():
    global c, a, idx, m, led1, led2, led3, led, T, count_sensors, firmware_version, measuretime, cx, pwmled, pwmleds, mtx, tx, rx, gx, bx, wx, cycle_counter
    logging.log(logging.TRACE0, '-')
    return cx


