import colorsys
import logging
import numpy as np

bw = None
fr = None
rgbw = None
hue_grad = None
value_perc = None
hsv = None
vmin = None
vmax = None
black_white = None
hexcode = None
hue_text = None
value_text = None
fixref = None
list_targets = None
list_targets_blocks = None


def init_rgbcolorsensorutil():
    global bw, fr, rgbw, hue_grad, value_perc, hsv, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE, '-')
    vmin = 65535
    vmax = 0
    black_white = False
    fixref = True
    list_targets = ['R', 'Y', 'G', 'B', 'W', 'D', '?']
    list_targets_blocks = ["<font color='#ff0000'>■</font>", "<font color='#ffff00'>■</font>", "<font color='#00ff00'>■</font>", "<font color='#0000ff'>■</font>", "<font color='#ffffff'>■</font>", "<font color='#000000'>■</font>", "<font color='#666666'>■</font>"]


def get_min():
    global bw, fr, rgbw, hue_grad, value_perc, hsv, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE0, '-')
    return vmin


def get_max():
    global bw, fr, rgbw, hue_grad, value_perc, hsv, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE0, '-')
    return vmax


def get_black_white():
    global bw, fr, rgbw, hue_grad, value_perc, hsv, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE0, '-')
    return black_white


def set_black_white(bw):
    global fr, rgbw, hue_grad, value_perc, hsv, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE, bw)
    black_white = bw


def set_fixref(fr):
    global bw, rgbw, hue_grad, value_perc, hsv, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE, fr)
    fixref = fr
    if not fr:
        vmin = 65535
        vmax = 0


def rgbw2hsv(rgbw):
    global bw, fr, hue_grad, value_perc, hsv, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE, rgbw)
    if (fixref):
      vmin = 0
      vmax = 10000
    else:
      vmin = min(vmin, min(rgbw))
      vmax = max(vmax, max(rgbw))
    if (black_white):
      vref = vmax
    else:
      vref = rgbw[3]
    if (vref!=0):
      h, s, v = colorsys.rgb_to_hsv(rgbw[0] / vref, rgbw[1] / vref, rgbw[2] / vref)
      hsv = [int(h * 360), int(s * 100), int(v * 100)]
      logging.log(logging.DEBUG, 'rgbw2hsv: {} {} {}'.format(str(rgbw), str(hsv), str([vmin, vmax])))
    else:
      logging.log(logging.ERROR, 'rgbw2hsv: {} {} {}'.format(str(hsv), str(rgbw), str(vref)))
    return hsv


def rgbw2hex(rgbw):
    global bw, fr, hue_grad, value_perc, hsv, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE, rgbw)
    vref = rgbw[3]
    if (vref!=0):
      hexcode = "#{:02x}{:02x}{:02x}".format(int(rgbw[0]/vref*255), int(rgbw[1]/vref*255), int(rgbw[2]/vref*255))
      logging.log(logging.DEBUG, hex)
    else:
      logging.log(logging.ERROR, 'error rgbw2hex')
    return hexcode


def hue2text(hue_grad):
    global bw, fr, rgbw, value_perc, hsv, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE, hue_grad)
    if hue_grad >= 0 and hue_grad < 9:
        hue_text = 'red'
    elif hue_grad >= 9 and hue_grad < 20:
        hue_text = 'red-orange'
    elif hue_grad >= 20 and hue_grad < 39:
        hue_text = 'orange-brown'
    elif hue_grad >= 39 and hue_grad < 51:
        hue_text = 'orange-yellow'
    elif hue_grad >= 51 and hue_grad < 60:
        hue_text = 'yellow'
    elif hue_grad >= 60 and hue_grad < 80:
        hue_text = 'yellow-green'
    elif hue_grad >= 80 and hue_grad < 138:
        hue_text = 'green'
    elif hue_grad >= 138 and hue_grad < 168:
        hue_text = 'green-cyan'
    elif hue_grad >= 168 and hue_grad < 200:
        hue_text = 'cyan'
    elif hue_grad >= 200 and hue_grad < 216:
        hue_text = 'cyan-blue'
    elif hue_grad >= 216 and hue_grad < 244:
        hue_text = 'blue'
    elif hue_grad >= 244 and hue_grad < 275:
        hue_text = 'blue-magenta'
    elif hue_grad >= 275 and hue_grad < 315:
        hue_text = 'magenta'
    elif hue_grad >= 315 and hue_grad < 340:
        hue_text = 'magenta-pink'
    elif hue_grad >= 340 and hue_grad < 350:
        hue_text = 'pink'
    elif hue_grad >= 350 and hue_grad < 357:
        hue_text = 'pink-red'
    elif hue_grad >= 357 and hue_grad < 360:
        hue_text = 'red'
    return hue_text


def value2text(value_perc):
    global bw, fr, rgbw, hue_grad, hsv, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE, value_perc)
    if value_perc >= 0 and value_perc < 20:
        value_text = 'very dark'
    elif value_perc >= 20 and value_perc < 40:
        value_text = 'dark'
    elif value_perc >= 40 and value_perc < 60:
        value_text = ''
    elif value_perc >= 60 and value_perc < 80:
        value_text = 'light'
    elif value_perc >= 80 and value_perc <= 100:
        value_text = 'very light'
    return value_text


def hsv2target(hsv):
    global bw, fr, rgbw, hue_grad, value_perc, vmin, vmax, black_white, hexcode, hue_text, value_text, fixref, list_targets, list_targets_blocks
    logging.log(logging.TRACE, hsv)
    hue_grad = hsv[0]
    value_perc = hsv[2]
    if black_white:
        if hue_grad >= 0 and hue_grad <= 360 and value_perc > 50:
            value_text = str(list_targets[4]) + str(list_targets_blocks[4])
        elif hue_grad >= 0 and hue_grad <= 360 and value_perc <= 50:
            value_text = str(list_targets[5]) + str(list_targets_blocks[5])
        else:
            pass
    else:
        if hue_grad >= 0 and hue_grad < 50:
            value_text = str(list_targets[0]) + str(list_targets_blocks[0])
        elif hue_grad >= 50 and hue_grad < 80:
            value_text = str(list_targets[1]) + str(list_targets_blocks[1])
        elif hue_grad >= 80 and hue_grad < 103:
            value_text = str(list_targets[2]) + str(list_targets_blocks[2])
        elif hue_grad >= 103 and hue_grad < 250:
            value_text = str(list_targets[3]) + str(list_targets_blocks[3])
        elif hue_grad >= 0 and hue_grad <= 360 and value_perc > 80:
            value_text = str(list_targets[4]) + str(list_targets_blocks[4])
        elif hue_grad >= 0 and hue_grad <= 360 and value_perc <= 0:
            value_text = str(list_targets[5]) + str(list_targets_blocks[5])
        else:
            value_text = str(hue_grad) + str(list_targets_blocks[6])
    return value_text


